Subject: Re: Comments on draft-walton-bgp-add-paths-00.txt

From: "John G. Scudder" <[email-masked]>
Date: Sat, 1 Jun 2002 15:17:34 -0400

At 11:35 AM -0700 5/31/02, Enke Chen wrote:
>The draft specifies a way to advertise and withdraw a path for a prefix. IMO
>per-path based update would require significant additional state 
>(i.e., per-path
>instead of per prefix) and memory in order to avoid spurious withdraws that we
>experienced in the past.
>
>We could avoid the additional state and simplify implementation if we treat
>all the paths of a prefix as one unit in advertisement and withdraw. By "one
>Unit" I mean that all paths are advertised (could be in multiple messages)
>together, and are withdrawn by the NLRI.
>
>This can be accomplished by introducing two additional bit flags for the
>reachable NLRIs:
>
>   o First Path Bit: When set, this indicates this is the first path for
>                     the prefix, and any existing paths should be removed.
>                     (This is similar to the current implicit replacement.)
>                     When clear, there is no implicit replacement.
>
>   o Last Path Bit:  When set, this indicates this is the last path, and
>                     bestpath selection should be done immediately. When
>                     clear, the bestpath selection may be deferred.
>                     This would help avoid FIB churn.
>
>Please note that with this approach there is no need to change the encoding
>of unreachable NLRIs, and the path "Identifier" field in the draft is no
>longer needed.

Enke,

This is slightly different from my earlier understanding of your 
suggestion.  I had understood that you were suggesting that the 
first/last path bits be optional.  I'm fine with them in that context.

However, it seems you are suggesting that the proposal be further 
modified so that use of first/last path would be the ONLY way to 
replace routes (this is implied by the suggestion that the ID field 
be dropped).  This could cause substantial inefficiency due to the 
need to re-advertise unchanged paths.  I'm not in favor of dropping 
the ID field.

Regards,

--John

---

From: Enke Chen <[email-masked]>
Date: Sat, 01 Jun 2002 13:17:31 -0700

Hi, John:

> Date: Sat, 1 Jun 2002 15:17:34 -0400
> To: Enke Chen <[email-masked]>
> From: "John G. Scudder" <[email-masked]>
> Subject: Re: Comments on draft-walton-bgp-add-paths-00.txt
> Cc: Alvaro Retana <[email-masked]>, [email-masked],
> 	[email-masked], [email-masked], [email-masked]
> 

There is a tradeoff between maintaing additional state with the per-path
based update and the duplicate path update with per-prefix based approach.
The suggestion I posted in the previous message is for "per-prefix" based
update.

Actually it seems to be mainly an implementation decision whether
to use per-path based update or per-prefix based update. The protocol
could be made flexiable to accomodate both implementations. For that
purpose, we will need to define a mechanism to withdraw all paths of
a prefix (w/o replacement path). This could be a via flag, or by using
a special ID number (e.g., the largest).

Thanks. -- Enke